//Behold... baby's first LUA spaghetti dish! Fear its overcomplicated recipe!

//a local function to make skinchecking easier
local function EmSkinCheck(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "emmette"
		return false
	end
	return true
end

/*this function just makes different jumps easier to manage since they all share
the same setup*/
local function JumpManager(player, height)
	if player.mo.eflags & MFE_VERTICALFLIP
		player.mo.momz = height * -1
	else
		player.mo.momz = height
	end
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if player.mo.eflags & MFE_UNDERWATER or player.powers[pw_spacetime] or 
			player.mo.eflags & MFE_GOOWATER
		if player.mo.eflags & MFE_VERTICALFLIP
			player.mo.momz = $ + ($ / 3)
		else
			player.mo.momz = $ - ($ / 3)
		end
	end
end

local function CrawlNPTrigger(player)
	if not EmSkinCheck(player)
		return
	end
	
	if player.pound == nil
		player.pound = false
	end
	//this makes the player crawl if they hold spin while on the ground
	if P_IsObjectOnGround(player.mo)
		player.height = player.spinheight
		player.normalspeed = 5 * FRACUNIT
		player.pflags = $ | PF_JUMPSTASIS
		if player.mo.momx != 0 and player.mo.momy != 0
			if not (player.mo.state == S_PLAY_CLIMB)
				player.mo.state = S_PLAY_CLIMB
			end
			if player.squishcue == nil
				player.squishcue = false
			end
			if (player.mo.frame & FF_FRAMEMASK) == 0 or (player.mo.frame & 
					FF_FRAMEMASK) == 2
				if not player.squishcue
					S_StartSound(player.mo, sfx_thok)
					player.squishcue = true
				end
			else
				player.squishcue = false
			end
		else
			player.mo.state = S_PLAY_GLIDE_LANDING
			player.squishcue = false
		end
	/*this triggers the boolean that runs the ground pound code if the player
	presses spin while in the air*/
	elseif (player.pflags & PF_JUMPED or player.mo.state == S_PLAY_FALL) and 
			player.powers[pw_carry] == CR_NONE and not (player.mo.state ==
			S_PLAY_CLING)
		player.mo.momx = 0
		player.mo.momy = 0
		JumpManager(player, 7 * FRACUNIT)
		player.hover = 1 * TICRATE
		player.pflags = $ & ~PF_THOKKED
		player.pound = true
	end
	return true
end
addHook("SpinSpecial", CrawlNPTrigger)

//this makes the player spin, since a lot of abilities make them spin
local function Speening(player)
	if player.speen == nil
		player.speen = 0
	end
	player.speen = $ + 45
	player.drawangle = FixedAngle(player.speen * FRACUNIT)
end

local function GroundPound(player)
	if not EmSkinCheck(player)
		return
	end
	
	//this resets the height and speed changes made by crawling
	if player.powers[pw_carry] == CR_NIGHTSMODE
		player.height = 46 * FRACUNIT
	elseif not (input.gameControlDown(GC_SPIN) and P_IsObjectOnGround(player.mo))
		player.height = skins[player.mo.skin].height
		player.normalspeed = skins[player.mo.skin].normalspeed
		if player.mo.state == S_PLAY_CLIMB
			player.mo.state = S_PLAY_WALK
		end
		player.squishcue = false
	end
	//this is the ground pound code
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.mo.state == S_PLAY_STUN
		player.pound = false
		return
	end
	if player.groundpound == nil
		player.groundpound = false
	end
	if player.pound
		player.pflags = $ | PF_FULLSTASIS
		if player.hover > 0
			if player.mo.momz == 0
				player.mo.momz = 0
			end
			player.mo.state = S_PLAY_FLY
			player.hover = $ - 8
		elseif not player.groundpound
			JumpManager(player, -50 * FRACUNIT)
			player.groundpound = true
		else
			if player.mo.eflags & MFE_GOOWATER or player.powers[pw_carry] != 
					CR_NONE or (player.mo.momz > 0 and not (player.mo.eflags & 
					MFE_VERTICALFLIP)) or (player.mo.momz < 0 and 
					player.mo.eflags & MFE_VERTICALFLIP)
				if player.powers[pw_carry] != CR_NONE
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_JUMP
				end
				player.groundpound = false
				player.pound = false
			elseif not P_IsObjectOnGround(player.mo)
				Speening(player)
				player.mo.state = S_PLAY_MELEE
				player.powers[pw_strong] = STR_FLOOR|STR_SPRING|STR_HEAVY|
						STR_STOMP|STR_ANIM
			else
				S_StartSound(player.mo, sfx_pstop)
				local px = player.mo.x
				local py = player.mo.y
				local br = 75 * FRACUNIT
				local mo = player.mo
				P_Earthquake(player.mo, player.mo, 90 * FRACUNIT)
				searchBlockmap("objects", function(mo, found)
					if found and found.valid and found.health and 
							P_CheckSight(mo, found) and (found.z < mo.z + 
							mo.height / 2 and found.z > mo.z - mo.height / 2)
						P_DamageMobj(found, mo, mo, 1, 0)
					end
				end, mo, px-br, px+br, py-br, py+br)
				JumpManager(player, 7 * FRACUNIT)
				player.mo.state = S_PLAY_JUMP
				player.groundpound = false
				player.pound = false
			end
		end
	end
end
addHook("PlayerThink", GroundPound)

local function MiscStuff(player)
	if not EmSkinCheck(player)
		return
	end
	
	//this allows the player to breathe underwater and in space due to nerfs
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		player.powers[pw_underwater] = $ + 1
	end
	if player.powers[pw_spacetime]
		player.powers[pw_spacetime] = $ + 1
	end
end
addHook("PlayerThink", MiscStuff)

//this makes it so the player can't grab air bubbles, since they don't need it
local function NoBubbles(special, toucher)
	if toucher.skin == "emmette"
		return true
	end
end
addHook("TouchSpecial", NoBubbles, MT_EXTRALARGEBUBBLE)

//these handle dust spawning for all the different jumps, since it's used a lot
local function SpawnDust(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(player.mo, 30 * FRACUNIT, 0, 0, MT_MEDIUMBUBBLE)
		P_SpawnMobjFromMobj(player.mo, -30 * FRACUNIT, 0, 0, MT_MEDIUMBUBBLE)
		P_SpawnMobjFromMobj(player.mo, 0, 30 * FRACUNIT, 0, MT_MEDIUMBUBBLE)
		P_SpawnMobjFromMobj(player.mo, 0, -30 * FRACUNIT, 0, MT_MEDIUMBUBBLE)
	else
		P_SpawnMobjFromMobj(player.mo, 30 * FRACUNIT, 0, 0, MT_ARIDDUST)
		P_SpawnMobjFromMobj(player.mo, -30 * FRACUNIT, 0, 0, MT_ARIDDUST)
		P_SpawnMobjFromMobj(player.mo, 0, 30 * FRACUNIT, 0, MT_ARIDDUST)
		P_SpawnMobjFromMobj(player.mo, 0, -30 * FRACUNIT, 0, MT_ARIDDUST)
	end
end

local function SpawnMoreDust(player)
	SpawnDust(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(player.mo, 60 * FRACUNIT, 0, 0, MT_SMALLBUBBLE)
		P_SpawnMobjFromMobj(player.mo, -60 * FRACUNIT, 0, 0, MT_SMALLBUBBLE)
		P_SpawnMobjFromMobj(player.mo, 0, 60 * FRACUNIT, 0, MT_SMALLBUBBLE)
		P_SpawnMobjFromMobj(player.mo, 0, -60 * FRACUNIT, 0, MT_SMALLBUBBLE)
	else
		P_SpawnMobjFromMobj(player.mo, 60 * FRACUNIT, 0, 0, MT_DUST)
		P_SpawnMobjFromMobj(player.mo, -60 * FRACUNIT, 0, 0, MT_DUST)
		P_SpawnMobjFromMobj(player.mo, 0, 60 * FRACUNIT, 0, MT_DUST)
		P_SpawnMobjFromMobj(player.mo, 0, -60 * FRACUNIT, 0, MT_DUST)
	end
end

local function SpawnTornadoDust(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		local tornadobubble = P_SpawnMobjFromMobj(player.mo, 0, 0, 0,
				MT_EXTRALARGEBUBBLE)
		tornadobubble.customAI = true
	else
		P_SpawnThokMobj(player)
	end
end

//this ensures any bubbles spawned in SpawnTornadoDust gets eventually removed
local function TornadoBubbles(mo)
	if mo.customAI == nil or not mo.customAI
		return
	end
	
	if mo.thinktimer == nil
		mo.thinktimer = 3 * TICRATE
	end
	if mo.thinktimer <= 0
		P_RemoveMobj(mo)
	else
		mo.thinktimer = $ - 1
	end
	return
end
addHook("MobjThinker", TornadoBubbles, MT_EXTRALARGEBUBBLE)

/*this disables her jump abilities while underwater or in space so long as she
doesn't have a whirlwind shield*/
local function WaterShieldCheck(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER or 
			player.powers[pw_spacetime]
		if not (player.powers[pw_shield] == SH_WHIRLWIND or 
				player.powers[pw_shield] & SH_PROTECTWATER)
			return false
		end
	end
	return true
end

local function LongJumpTornado(player)
	if not EmSkinCheck(player)
		return
	end
	
	if player.haslongjumped == nil
		player.haslongjumped = false
	end
	if player.highthirdjumped == nil
		player.highthirdjumped = 0
	end
	if P_PlayerInPain(player) or player.playerstate == PST_DEAD or 
			player.powers[pw_carry] != CR_NONE
		player.haslongjumped = false
		player.highthirdjumped = 0
		return
	end
	if not WaterShieldCheck(player)
		player.haslongjumped = false
		return
	end
	//This makes the player spin in the air while high-jumping
	if player.pflags & PF_THOKKED and not player.haslongjumped
		if (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0
			if not (player.mo.state == S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
			end
			Speening(player)
			if player.mo.momz / FRACUNIT < -10
				SpawnTornadoDust(player)
			end
		elseif not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
			if not (player.mo.state == S_PLAY_JUMP)
				player.mo.state = S_PLAY_JUMP
			end
			Speening(player)
			if player.mo.momz / FRACUNIT > 10
				SpawnTornadoDust(player)
			end
		end
		return
	end
	//This spawns a ghost trail while the player is long jumping/diving
	if player.haslongjumped
		P_SpawnGhostMobj(player.mo)
	end
	if P_IsObjectOnGround(player.mo) or player.mo.state == S_PLAY_RIDE
		player.haslongjumped = false
		player.highthirdjumped = 0
	//This activates a long jump/dive if the player presses custom 1
	elseif input.gameControlDown(GC_CUSTOM1) and not (player.mo.state == 
			S_PLAY_CLING or player.pound)
		if not player.haslongjumped
			SpawnDust(player)
			S_StartSound(player.mo, sfx_s3k4b)
			local longspeed = player.normalspeed + player.normalspeed / 8
			P_InstaThrust(player.mo, player.mo.angle, longspeed)
			player.mo.state = S_PLAY_ROLL
			player.powers[pw_strong] = STR_WALL|STR_ANIM
			JumpManager(player, 10 * FRACUNIT)
			player.pflags = $ | PF_SPINNING
			player.haslongjumped = true
		end
	end
	//this makes the player perform a tornado move for a less risky attack
	if player.trndocue == nil
		player.trndocue = 0
	end
	if input.gameControlDown(GC_CUSTOM2) and not (player.haslongjumped or 
			player.pound or input.gameControlDown(GC_SPIN))
		if P_IsObjectOnGround(player.mo)
			JumpManager(player, 7 * FRACUNIT)
			SpawnDust(player)
		end
		P_SpawnSkidDust(player, 25 * FRACUNIT)
		if player.trndocue <= 0
			S_StartSound(player.mo, sfx_prloop)
			player.trndocue = 2 * TICRATE
		else
			player.trndocue = $ - 5
		end
		Speening(player)
		player.mo.state = S_PLAY_CLING
		player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_ANIM
		if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0) or
				(not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0)
			JumpManager(player, -2 * FRACUNIT)
		end
	else
		if player.mo.state == S_PLAY_CLING
			player.mo.state = S_PLAY_FALL
		end
		player.trndocue = 0
	end
end
addHook("PlayerThink", LongJumpTornado)

local function HighNThirdJump(player)
	if not EmSkinCheck(player)
		return
	end
	
	if not WaterShieldCheck(player)
		player.highthirdjumped = 0
		return true
	end
	/*this makes it so the player can't high jump if they're long jumping or
	doing the tornado*/
	if player.haslongjumped or player.mo.state == S_PLAY_CLING
		player.highthirdjumped = 0
		return true
	end
	//this makes the player perform the high jump
	if player.highthirdjumped <= 0
		player.mo.state = S_PLAY_JUMP
		player.haslongjumped = false
		SpawnMoreDust(player)
		S_StartSound(player.mo, sfx_wdjump)
		player.pflags = $ | PF_THOKKED
		JumpManager(player, 20 * FRACUNIT)
		player.mo.momx = $ / 4
		player.mo.momy = $ / 4
		player.highthirdjumped = 1
	/*this makes the player perform an extra little hop that thrusts the
	player forward after high-jumping*/
	elseif player.highthirdjumped == 1
		player.mo.state = S_PLAY_JUMP
		SpawnDust(player)
		S_StartSound(player.mo, sfx_wirlsg)
		P_InstaThrust(player.mo, player.mo.angle, player.normalspeed)
		JumpManager(player, 7 * FRACUNIT)
		player.highthirdjumped = 2
	end
	return true
end
addHook("AbilitySpecial", HighNThirdJump)